<template>
  <div class="q-pa-md padding-lg">
    <div class="q-pa-md column items-center" v-if="!isLoggedIn">
      <q-avatar size="72px">
        <img src="../../assets/logo_shopping_cart.svg" />
      </q-avatar>
      <h5
        class="text-h5 text-weight-medium"
      >Se pare ca inca nu ai un cont. Logheaza-te sau creeaza unul!</h5>
      <q-btn
        :to="{ name: auth }"
        flat
        no-caps
        size="md"
        style="color: #818078"
        label="Autentificare"
      />
    </div>
    <div v-else>
      <div class="order-subtitle q-px-lg row">
        <div class="col-6">
          <p class="text-caption text-weight-medium">Profilul tau</p>
          <h5 class="text-h5">
            <span class="text-weight-medium">{{currentUser.firstName}} &nbsp;</span>
            <span class="text-weight-light text-primary">{{currentUser.lastName}}</span>
          </h5>
        </div>

        <div class="col-6 text-justify column items-end justify-end">
          <p>{{currentUser.email}}</p>
          <p>{{currentUser.phone}}</p>
        </div>
      </div>

      <q-separator inset />

      <div class="row q-py-lg justify-center q-col-gutter-xl q-px-lg margin-lg">
        <div class="col-xs-12 col-sm-4 col-4">
          <p>{{currentUser.address}}, {{currentUser.city}}, {{currentUser.state}}, {{currentUser.zip}}</p>
          <q-btn
            v-if="currentUser.cardNumber"
            @click="showSensibleInfo=true"
            outline
            class="q-my-md"
            color="primary"
            label="Vezi info card"
          />
          <div v-if="showSensibleInfo==true" class="column">
            <q-card class="my-card q-mt-md bg-grey-2">
              <q-card-section>
                <p>{{currentUser.nameOnCard}}</p>
                <p>{{currentUser.cardNumber}}</p>
              </q-card-section>
              <q-card-section>
                <div class="row justify-between">
                  <div class="column items-start">
                    <p class="text-caption q-mb-none">CVV</p>
                    <p>{{currentUser.cvv}}</p>
                  </div>
                  <div class="column items-end">
                    <p class="text-caption q-mb-none">EXP. DATE</p>
                    <p>{{currentUser.expDate}}</p>
                  </div>
                </div>
              </q-card-section>
            </q-card>

            <q-btn
              @click="showSensibleInfo=false"
              flat
              style="color: #818078"
              label="Ascunde"
              no-caps
            />
          </div>

          <p
            class="text-caption q-pt-sm"
          >*Poti schimba aceste detalii la urmatoarea tranzactie, la detaliile de facturare</p>
        </div>
        <div class="col-xs-12 col-sm-8 col-8">
          <p class="text-subtitle1 text-weight-medium">Comenzile tale</p>
          <q-table
            class="my-sticky-header-table"
            :data="currentUserProducts"
            :columns="columns"
            row-key="id"
            separator="vertical"
            :pagination.sync="pagination"
            :rows-per-page-options="[0]"
            flat
            :visible-columns="visibleColumns"
            virtual-scroll
            :filter="filter"
          >
            <template v-slot:top-right>
              <q-input borderless dense debounce="300" v-model="filter" placeholder="Search">
                <template v-slot:append>
                  <q-icon name="search" />
                </template>
              </q-input>
            </template>
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th auto-width />
                <q-th v-for="col in props.cols" :key="col.name" :props="props">{{ col.label }}</q-th>
              </q-tr>
            </template>

            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td auto-width>
                  <q-btn
                    size="sm"
                    color="accent"
                    @click="viewProductDetails(props.row)"
                    round
                    dense
                    icon="add"
                  />
                </q-td>
                <q-td v-for="col in props.cols" :key="col.name" :props="props">{{ col.value }}</q-td>
              </q-tr>
            </template>
          </q-table>
        </div>
      </div>

      <q-dialog v-model="openDialogDetails">
        <q-card style="width: 700px; max-width: 60vw; ">
          <q-card-section class="row justify-between q-pb-none">
            <p class="text-primary text-subtitle1 text-weight-medium">Total comanda</p>
            <p class="text-weight-medium">{{selectedProduct.total}} RON</p>
          </q-card-section>
          <q-separator />
          <q-card-section>
            <div
              v-for="(product, index) in selectedProduct.items"
              :key="product.id"
              class="q-px-lg q-my-lg"
            >
              <div class="row q-px-sm justify-between">
                <div class="row">
                  <p>{{index+1}}&nbsp;</p>
                  <q-separator vertical inset />
                  <p>
                    <span class="text-primary">&nbsp;{{product.quantity}}&nbsp;x</span>
                    &nbsp;&nbsp;&nbsp;{{product.detail.name}}, {{product.preference.color}}, {{product.preference.size}}
                  </p>
                </div>

                <p
                  class="text-subtitle1 text-weight-medium"
                >{{product.quantity * product.detail.price}} RON</p>
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-pb-none" v-if="selectedProduct.voucher">
            <p>
              <span class="text-primary">Discount:</span> &nbsp;
              <span
                class="text-weight-medium"
              >{{selectedProduct.voucher.value}} {{selectedProduct.voucher.type=='percent'?'%':'RON'}}</span>
            </p>
          </q-card-section>
          <q-card-section class="q-py-none">
            <p>
              <span class="text-primary">Status plata:</span> &nbsp;
              <span
                class="text-weight-medium"
              >{{selectedProduct.isPaid?'A fost platita':'Nu a fost platita'}}</span>
            </p>
          </q-card-section>
          <q-card-section class="q-pt-none q-pb-sm" align="right">
            <q-btn
              v-if="selectedProduct.status != 'CANCELED'"
              @click="cancelOrder()"
              no-caps
              flat
              color="negative"
              label="Anuleaza comanda"
            />
            <q-btn @click="openDialogDetails=false" no-caps flat color="negative" label="Inapoi" />
          </q-card-section>
        </q-card>
      </q-dialog>
    </div>
  </div>
</template>

<script>
//DE FACUT SCHIMBARE PAROLA
import { LocalStorage } from "quasar";

export default {
  name: "profile",
  data() {
    return {
      filter: "",
      auth: "auth",
      showSensibleInfo: false,
      openDialogDetails: false,
      pagination: {
        rowsPerPage: 100,
      },
      selectedProduct: {},
      visibleColumns: ["status", "createdAt", "deliveryDate", "total"],
      columns: [
        {
          name: "status",
          label: "Status",
          field: "status",
          align: "center",
          sortable: true,
        },
        {
          name: "createdAt",
          label: "Data comenzii",
          align: "center",
          field: (row) => row.createdAt,
          format: (val) => `${val.substring(0, 10)}`,
          sortable: true,
        },
        {
          name: "deliveryDate",
          label: "Data livrare",
          field: "deliveryDate",
          align: "center",
          sortable: true,
        },
        {
          name: "total",
          label: "Valoare totala",
          sortable: true,
          align: "center",
          field: (row) => row.total,
          format: (val) => `${val} RON`,
        },
        {
          name: "totals",
          label: "Valoare totala",
          sortable: true,
          align: "center",
          hide: true,
          searchable: true,
          field: (row) => row.products,
          format: (val) => `${val} RON`,
        },
      ],
      isLoggedIn: false,
    };
  },
  beforeMount() {
    if (LocalStorage.getItem("loggedIn")) {
      this.isLoggedIn = true;
    }
  },

  computed: {
    currentUser() {
      return LocalStorage.getItem("user");
    },
    currentUserProducts() {
      return this.$store.getters["adminData/getCurrentUserProducts"].map(
        (item) => {
          let products = "";
          item.items.forEach((x) => (products += x.detail.name));
          return { ...item, products };
        }
      );
    },
  },
  methods: {
    viewProductDetails(product) {
      this.openDialogDetails = true;
      this.selectedProduct = { ...product };
    },
    cancelOrder() {
      this.$q
        .dialog({
          message: `Sunteti sigur ca vreti sa anulati comanda?`,
          color: "red-9",
          cancel: true,
          persistent: true,
        })
        .onOk(() => {
          this.$axios
            .put("/api/purchases", {
              id: this.selectedProduct.id,
              status: "CANCELED",
            })
            .then((response) => {
              this.$q.notify({
                message: response.data.message,
                color: "positive",
              });
              this.$store.dispatch("adminData/loadCurrentUserProducts");
              this.openDialogDetails = false;
            })
            .catch((error) => {
              this.$q.notify({
                color: "negative",

                message: error.response.data.message,
                icon: "report_problem",
              });
            });
        })
        .onCancel(() => {});
    },
  },
};
</script>

<style lang="scss" scoped>
.order-subtitle,
.info-subtitle,
.product-price,
.order-total {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}
.padding-lg {
  padding-left: 5%;
  padding-right: 5%;
}
.my-card {
  width: 100%;
}
</style>